﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.DataPreprocessing;

namespace HeuristicLab.DataPreprocessing {
  public class DataGridLogic : IDataGridLogic {

    private IPreprocessingData preprocessingData;

    public DataGridLogic(IPreprocessingData preprocessingData) {
      this.preprocessingData = preprocessingData;
    }

    public IEnumerable<string> GetVariableNames()
    {
      return preprocessingData.VariableNames;
    }

    public IList<IList<string>> GetAllValues() {

      IEnumerable<string> variableNames = preprocessingData.VariableNames;
      IList<IList<string>> allValues = new List<IList<string>>();

      IList<IEnumerable<string>> columnValuesList = new List<IEnumerable<string>>();

      foreach (string variableName in variableNames) {

        columnValuesList.Add(preprocessingData.GetValues<string>(variableName));
      }


      if (columnValuesList.Count > 0) {
        for (int i = 0; i < columnValuesList.ElementAt(0).Count(); i++) {
          allValues.Add(new List<string>());
          foreach (IEnumerable<string> columnValues in columnValuesList) {
            allValues[i].Add(columnValues.ElementAt(i));
          }
        }
      }
      return allValues;
    }
    
  }
}
